// STEP 4 - calculate redness 
// ask for normalization area
// calculate R/(R+G+B)

waitForUser("Please select the normalization area");
setSelectionName("control");
roiManager("Add");

rednessValues = newArray(nResults / 3);
labels = newArray(nResults / 3);
 
for (i=0; i<nResults; i=i+3) {
    red = getResult("Mean", i);
    green = getResult("Mean", i+1);
    blue = getResult("Mean", i+2);
   rednessValues[i/3] = red / (red + green + blue);
   aLabel = getResultLabel(i);
   parts = split(aLabel, ":");
   labels[i/3] = parts[0];
}

setSlice(1);
roiManager("Measure");
setSlice(2);
roiManager("Measure");
setSlice(3);
roiManager("Measure");
roiManager("Delete");
redControl = getResult("Mean", nResults-3);
greenControl = getResult("Mean", nResults-2);
blueControl = getResult("Mean", nResults-1);
rednessMax = redControl / (redControl + greenControl + blueControl);
IJ.deleteRows(nResults-3, nResults-1);

windowTitles = getList("window.titles");
isRednessTableOpen = false;
for (i=0; i < windowTitles.length; i++) {
      if (windowTitles[i]=="redness-measurements") isRednessTableOpen = true;
}


if (!isRednessTableOpen)  {
	run("Table...", "name=redness-measurements width=550 height=250");
	print("[redness-measurements]", "\\Headings:n\tLabel\tredness raw\tredness norm\tredness max");
	index = 1;
} else {
 	selectWindow("redness-measurements");
	info = split(getInfo("window.contents"), "\n");
	index = lengthOf(info);
}

numberOfLabels = lengthOf(labels);
for(i=0; i<lengthOf(rednessValues); i++) {
  if (labels[i]==labels[numberOfLabels-1]) {
      line = "" + index + "\t" + labels[i] + "\t" + d2s(rednessValues[i], 4) + "\t" + d2s((rednessValues[i] / rednessMax),4) + "\t" + d2s(rednessMax,4);
      print("[redness-measurements]", line);
      index++;
   }
}

